#!/usr/bin/perl

use CGI qw(:standard escapeHTML);
#use CGI::Carp (fatalsToBrowser);
use LWP::UserAgent;
use HTTP::Request;
use HTTP::Response;
use URI::Heuristic;

$|=1;

$ENGINE  = "/var/lib/apache/cgi-bin/geo-conv.pl";
$REVTRAN = "/var/lib/apache/cgi-bin/lat-geo.pl";
$GEOTRANS = "/var/lib/apache/cgi-bin/trans-geo.pl";
$USER_LOGFILE = "geo-conv-user.log";
$WORK_LOGFILE = "geo-conv-work.log";
$USER_LOGGING = 1;
$WORK_LOGGING = 1;
$THRESH_LAT = 0.70;

%encodings = ('GOV' => 'w', 'BPG' => 'k', 'LATIN' => 'l', 'GEOTRANS' => 't');

# get the input -- URL, file, or text
$what = param('WHAT');
($what eq 'TEXT') && do {
   $content = "text/plain";
   $input = param('INPUT')
};
($what eq 'FILE') && do { 
   $content = "text/plain";
   $filehandle = param('FILENAME');
   undef $/;
   $input = (<$filehandle> || "Error: Could not open the file specified")
};
($what eq 'URL')  && do {
   $content = "text/html";
   $raw_url = param('URL');
   $url = URI::Heuristic::uf_urlstr($raw_url);
   $ua = LWP::UserAgent->new();
   $ua->agent("mozilla");
   $req = HTTP::Request->new(GET=>$url);
   $req->referer("http://www.kgb.su");
   $response = $ua->request($req);
   if ($response->is_error()) {
      printf " %s\n", $response->status_line;
   } else {
      $input = $response->content();
   }
};

# HTMLize quotes
#$input =~ s/\&/&#038\;/g;
#$input =~ s/\$/&#036\;/g;
#$input =~ s/\\/&#092\;/g;
$input =~ s/\"/&#034\;/g;
$input =~ s/\'\'//g;
$input =~ s/\'//g;
$input =~ s/\`/\\\`/g;

# save things for logging
$orig_input = $input;
$time = localtime;

# how to recode, manually or automatically
if (param('HOW') eq 'MAN') 
#  manually -- just get the from & to
   {
   $encout = join('', $encodings{param('FROM')}, $encodings{param('INTO')})
   }
#  automatically -- if more than $THRESH_LAT of chars are Latin,
#  assume it's Latin and reverse transliterate
   else {
   $inputnospace = $input;
   $inputnospace =~ s/\s//g;
   $allchars = length $inputnospace;
   $latchars = ($inputnospace =~ y/a-zA-Z/a-zA-Z/);
   $encout = ($latchars > $THRESH_LAT * $allchars) ?
       join('', 'l', $encodings{param('AUTO_INTO')}) :
       $encodings{param('AUTO_INTO')}
   };
$orig_encout = $encout;

### quick patch for reverse translit.
### will rewrite more accurately later
$encout =~ /[lt]./ && do {
   (substr($encout,0,1) eq 'l') ?
   ($output = `echo "$input" | "$REVTRAN"`) :
   ($output = `echo "$input" | "$GEOTRANS"`) ;
   $input = $output;
   $input =~ s/\`/\\\`/g;
   substr($encout, 0, 1) = 'k';
};
### end patch

# DO IT!
$output = `echo "$input" | "$ENGINE" "$encout"`;

# log users
$USER_LOGGING && do {
   open LOG, ">> $USER_LOGFILE";
   $user = ($ENV{REMOTE_HOST} || $ENV{REMOTE_ADDR});
   print LOG "$time -- $user\n";
   close LOG
};

# log input & output
$WORK_LOGGING && do {
   open LOG, ">> $WORK_LOGFILE";
   print LOG "=============   WHO:\n";
   $user = ($ENV{REMOTE_HOST} || $ENV{REMOTE_ADDR});
   print LOG "$time -- $user\n";
   print LOG "=============   MODE:\n";
   print LOG "$orig_encout\n";
   print LOG "=============   WHAT:\n";
   print LOG "$what\n";
   print LOG "=============   INPUT:\n";
   print LOG "$orig_input\n";
   print LOG "=============   OUTPUT:\n";
   print LOG "$output\n";
   print LOG "=======================\n";
   close LOG
};

# deHTMLize quotes
$output =~ s/&#034\;/\"/g;
$output =~ s/\\\`/\`/g;

print "Cache-Control: no-cache\n";
print "Content-Type: $content\n\n";
#print "$latchars $allchars <P>";
print $output;
