#!/usr/bin/perl

##################################################################
# Copyright (C) 1998 Stefan Mashkevich <mash@mashke.org>
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License.
# Disclaimer: The program is provided "as is" and there is no
# warranty of any kind whatsoever. Your using it is at your own risk.
##################################################################
# converting transliterated text into KOI-8
#
# v0.8 S.Mashkevich  13 Dec 1998
# v0.9 S.Mashkevich  19 Jan 1999
#      revision 5    20 Nov 1999
#      revision 7    17 Feb 2000
#      revision 8    03 May 2000

# text on standard input, recoded on standard output
#
##################################################################
$SEPARATOR = '|';

# extra symbols that count as letters (that figure in translit patterns)
$extrasyms = "\'\`\^\~";

# read in translit patterns

$maxlen = 0;
$translitflag = 1;

while (<DATA>) {
   next if /^#/;
   @chars = /([\w$extrasyms:]+)\s+([\200-\377]+)/g;
   for ($i = 0; $i < @chars; $i += 2) {
      $orig = $chars[$i]; $orig =~ s/\"//g;
      $len = length $orig; $maxlen = $len  if  $len > $maxlen;
      $repl = $chars[$i+1]; $repl =~ s/\"//g;
      $trans[$len]{$orig} = $repl;
   }
};

#for ($len = $maxlen; $len > 0; $len--) {
#   print "$len :\n";
#   for $orig (keys %{$trans[$len]}) {print "$orig->$trans[$len]{$orig}\n"}
#};

##################################################################
# convert

undef $/;
$in = <STDIN>; $in = ':'.$in; $inlength = length $in; $offset = 0;
$out = "";
LOOP: while ($offset < $inlength) {
   if ($translitflag)
   {
   for ($len = $maxlen; $len > 0; $len--) {
      $pattern = $patwopunct = substr($in, $offset, $len);
      if ($patwopunct =~ s/[^\w$extrasyms]/:/g) {  # there are non-letters
          if (defined ($repl = $trans[$len]{$patwopunct})) {
              $pattorep = $translit = $pattern;
              $pattorep =~ s/[^\w$extrasyms]//g;   # delete non-letters
              $translit =~ s/[^\w$extrasyms]$//  &&  $len--;   # if last is non-letter,
                  # we may need it for next transliteration
              $translit =~ s/$pattorep/$repl/;
              $out .= $translit;
              $offset += $len;
              next LOOP
              }
      } else {
          if (defined ($translit = $trans[$len]{$pattern})) {
              $out .= $translit;
              $offset += $len;
              next LOOP
              }
      }
   };
   } else
   {
   $pattern = substr($in, $offset, 1);
   };
   if ($pattern eq $SEPARATOR)
      {$translitflag = 1-$translitflag}
   else
      {$out .= $pattern};
   $offset += 1;
};
$out = substr($out, 1);
##################################################################
# output

print $out;

##################################################################
__END__
#
# lat_chars Geo_chars, any number of pairs in line
# colon means noncharacter (space, comma etc)
a    b    c    d    e    f    g    h    i    j    k    l    m    
n    o    p    q    r    s    t    u    v    w    x    y    z 
A    B    C    D    E     F    G    H    I    J    K    L    M 
N    O   P    Q    R    S    T    U    V    W    X    Y    Z 
# from here starts georgian trnaslit letters. you can use them as '7bit' letters
# presented above
ts    ch    sh    gh    dz    kh   tch   th    ph  
`e   `v    `h    `i   `x  


