#!/usr/bin/perl

##################################################################
# Copyright (C) 1998 Stefan Mashkevich <mash@mashke.org>
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License.
# Disclaimer: The program is provided "as is" and there is no
# warranty of any kind whatsoever. Your using it is at your own risk.
##################################################################
# converting transliterated text into KOI-8
#
# v0.8 S.Mashkevich  13 Dec 1998
# v0.9 S.Mashkevich  19 Jan 1999

# text on standard input, recoded on standard output
#
##################################################################
$SEPARATOR = '|';

# read in translit patterns

$maxlen = 0;
$translitflag = 1;

while (<DATA>) {
   next if /^#/;
   @chars = /([\w\'\`:]+)\s+([i\'\200-\377]+)/g;
#  difference from Russian above: i and ' (apostrophe) are Ukr. chars
   for ($i = 0; $i < @chars; $i += 2) {
      $orig = $chars[$i]; $orig =~ s/\"//g;
      $len = length $orig; $maxlen = $len  if  $len > $maxlen;
      $repl = $chars[$i+1]; $repl =~ s/\"//g;
      $trans[$len]{$orig} = $repl;
   }
};

#for ($len = $maxlen; $len > 0; $len--) {
#   print "$len :\n";
#   for $orig (keys %{$trans[$len]}) {print "$orig->$trans[$len]{$orig}\n"}
#};

##################################################################
# convert

undef $/;
$in = <STDIN>; $inlength = length $in; $offset = 0;
$out = "";
LOOP: while ($offset < $inlength) {
   if ($translitflag)
   {
   for ($len = $maxlen; $len > 0; $len--) {
      $pattern = $patwopunct = substr($in, $offset, $len);
      if ($patwopunct =~ s/[^\w\'\`]/:/g) {  # there are non-letters
          if (defined ($repl = $trans[$len]{$patwopunct})) {
              $pattorep = $translit = $pattern;
              $pattorep =~ s/[^\w\'\`]//g;   # delete non-letters
              $translit =~ s/[^\w\'\`]$//  &&  $len--;   # if last is non-letter,
                  # we may need it for next transliteration
              $translit =~ s/$pattorep/$repl/;
              $out .= $translit;
              $offset += $len;
              next LOOP
              }
      } else {
          if (defined ($translit = $trans[$len]{$pattern})) {
              $out .= $translit;
              $offset += $len;
              next LOOP
              }
      }
   };
   } else
   {
   $pattern = substr($in, $offset, 1);
   };
   if ($pattern eq $SEPARATOR)
      {$translitflag = 1-$translitflag}
   else
      {$out .= $pattern};
   $offset += 1;
};
##################################################################
# output

print $out;

##################################################################
__END__
#
# lat_chars geo_chars, any number of pairs in line
# colon means noncharacter (space, comma etc)
a    b    c    d    e    f    g    h    i    j    k    l    m 
n    o    p    q    r    s    t    u    v    w    x    y    z 
A    B    C    D    E    F    G    H    I I   J    K    L    M 
N    O    P    Q    R    S    T    U    V    W    X    Y    Z 
ts    tch    gh    th    sh    ch    dz ۠  jh   ph 
`e   `i     `x     `h    `v 
